// List of words to monitor
const badWords = [
    'fuck', 'fucking', 'fucked', 'fucker', 'fucks', 'motherfucker', 'motherfucking',
    'shit', 'shitting', 'shitty', 'shat', 'bullshit', 'horseshit',
    'damn', 'damnit', 'damned', 'goddamn', 'goddamnit', 'goddarn',
    'ass', 'asshole', 'asses', 'jackass', 'dumbass', 'badass',
    'bitch', 'bitching', 'bitches', 'sonofabitch',
    'crap', 'crappy', 'crapped',
    'hell', 'hellish', 'what the hell', 'to hell',
    'piss', 'pissed', 'pissing', 'pisses', 'piss-off',
    'bastard', 'bastards',
    'dick', 'dickhead', 'dicking', 'dicks', 'dickwad', 'dickweed',
    'cock', 'cocksucker', 'cocky', 'cocked',
    'slut', 'slutty', 'sluts',
    'whore', 'whores', 'whoring',
    'jerk', 'jerking', 'jerked',
    'prick', 'pricks', 'pricking',
    'freak', 'freaking', 'freaked',
    'douche', 'douchebag', 'douches',
    'moron', 'morons',
    'idiot', 'idiots',
    'imbecile', 'imbeciles',
    'scum', 'scumbag', 'scumbags',
    'retard', 'retarded',
    'screw', 'screwing', 'screwed', 'screws', 'screw-up',
    'loser', 'losers',
    'suck', 'sucking', 'sucker', 'sucked', 'sucks'
];

// Create warning element
const warningElement = document.createElement('div');
warningElement.style.cssText = `
  position: fixed;
  top: 20px;
  right: 20px;
  background-color: #ff4444;
  color: white;
  padding: 15px;
  border-radius: 5px;
  z-index: 10000;
  display: none;
  font-size: 18px;
  font-weight: bold;
  box-shadow: 0 2px 5px rgba(0,0,0,0.2);
`;
document.body.appendChild(warningElement);

// Add a global flag to prevent double initialization
if (typeof window.languagePoliceInitialized === 'undefined') {
    window.languagePoliceInitialized = true;

    // Move recognition setup into a function
    let recognition = null;
    let isRecognitionActive = false;

    // Listen for toggle events
    window.addEventListener('toggleLanguagePolice', (event) => {
        console.log('Toggle event received:', event.detail.isActive);
        if (event.detail.isActive) {
            if (!recognition) {
                initializeRecognition();
            }
            startRecognition();
        } else if (recognition && isRecognitionActive) {
            recognition.stop();
            isRecognitionActive = false;
        }
    });

    function startRecognition() {
        if (!isRecognitionActive) {
            isRecognitionActive = true;
            recognition.start();
            console.log('Starting speech recognition...');
        }
    }

    function initializeRecognition() {
        if (recognition) return; // Already initialized
        
        console.log('Initializing speech recognition...');
        recognition = new webkitSpeechRecognition();
        recognition.continuous = true;
        recognition.interimResults = true;
        recognition.lang = 'en-US';
        
        // Keep track of the last processed transcript length
        let lastProcessedLength = 0;

        // Add debug output for when recognition starts
        recognition.onstart = () => {
            console.log('Speech recognition started');
            lastProcessedLength = 0;
        };

        // Add auto-restart mechanism
        isRecognitionActive = false;

        // Add debug output for when recognition ends
        recognition.onend = () => {
            console.log('Speech recognition ended');
            isRecognitionActive = false;
            // Restart after a short delay
            setTimeout(() => {
                startRecognition();
            }, 1000);
        };

        recognition.onresult = (event) => {
            // Get the full transcript
            const transcript = Array.from(event.results)
                .map(result => result[0].transcript.toLowerCase())
                .join('');
            
            // Debug output
            console.log('Full transcript:', transcript);
            
            // Get only the new part of the transcript
            const newText = transcript.slice(lastProcessedLength);
            console.log('New text:', newText);
            
            // Get the last three words
            const words = newText.trim().split(/\s+/);
            const lastThreeWords = words.slice(-3).join(' ');
            console.log('Last three words:', lastThreeWords);
            
            // Update the processed length
            lastProcessedLength = transcript.length;
            
            // Check for bad words only in the last three words
            badWords.forEach(word => {
                if (lastThreeWords.includes(word)) {
                    console.log('Bad word detected:', word);
                    showWarning();
                }
            });
        };

        recognition.onerror = (event) => {
            console.error('Speech recognition error:', event.error);
            
            if (event.error === 'no-speech') {
                console.log('No speech detected, restarting...');
                isRecognitionActive = false;
                // Restart after a short delay
                setTimeout(() => {
                    startRecognition();
                }, 1000);
            }
        };

        // Start the initial recognition
        startRecognition();

        // Function to show warning
        function showWarning() {
            warningElement.textContent = "Language!";
            warningElement.style.display = 'block';
            
            // Hide warning after 2 seconds
            setTimeout(() => {
                warningElement.style.display = 'none';
            }, 2000);
        }
    }
}